diff --git a/vagrant/README.rst b/vagrant/README.rst
new file mode 100644
index 0000000..577d05c
--- /dev/null
+++ b/vagrant/README.rst
@@ -0,0 +1,35 @@
+Development environment for MONARC
+==================================
+
+Vagrant is convenient to use in order to setup your development environment.
+
+This VM uses `synced folders `_
+feature of Vagrant in order to let you work on the MONARC source code on your
+host machine while the softwares (Apache, PHP, MariaDB, etc.) and libraries
+will be installed on the guest Vagrant machine.
+
+
+Installation of VirtualBox and Vagrant
+--------------------------------------
+
+.. code-block:: bash
+
+ $ sudo apt-get install virtualbox vagrant
+
+
+Deployment of the front office
+------------------------------
+
+MONARC will be automatically deployed in an Ubuntu Zesty Server.
+
+.. code-block:: bash
+
+ $ git clone https://github.com/monarc-project/MonarcAppFO
+ $ cd MonarcAppFO/vagrant
+ $ export GITHUB_AUTH_TOKEN=
+ $ vagrant up
+
+Once the VM will be configured by Vagrant, go to the address
+http://127.0.0.1:5001.
+
+The username is *admin@admin.test* and the password is *admin*.
diff --git a/vagrant/Vagrantfile b/vagrant/Vagrantfile
new file mode 100644
index 0000000..d1d008d
--- /dev/null
+++ b/vagrant/Vagrantfile
@@ -0,0 +1,127 @@
+# -*- mode: ruby -*-
+# vi: set ft=ruby :
+
+# Vagrantfile API/syntax version. Don't touch unless you know what you're doing!
+VAGRANTFILE_API_VERSION = "2"
+
+Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
+ # All Vagrant configuration is done here. The most common configuration
+ # options are documented and commented below. For a complete reference,
+ # please see the online documentation at vagrantup.com.
+
+ # Every Vagrant virtual environment requires a box to build off of.
+ #config.vm.box = "bento/ubuntu-16.04"
+ config.vm.box = "ubuntu/zesty64"
+ #config.vm.box_url = "https://atlas.hashicorp.com/ubuntu/boxes/zesty64/versions/20170412.1.0"
+ config.vm.provision :shell, path: "bootstrap.sh", args: "#{ENV['GITHUB_AUTH_TOKEN']}"
+
+ # Disable automatic box update checking. If you disable this, then
+ # boxes will only be checked for updates when the user runs
+ # `vagrant box outdated`. This is not recommended.
+ # config.vm.box_check_update = false
+
+ # Create a forwarded port mapping which allows access to a specific port
+ # within the machine from a port on the host machine. In the example below,
+ # accessing "localhost:8080" will access port 80 on the guest machine.
+ config.vm.network :forwarded_port, guest: 80, host: 5001
+
+ # Create a private network, which allows host-only access to the machine
+ # using a specific IP.
+ # config.vm.network "private_network", ip: "192.168.33.10"
+
+ # Create a public network, which generally matched to bridged network.
+ # Bridged networks make the machine appear as another physical device on
+ # your network.
+ # config.vm.network "public_network"
+
+ # If true, then any SSH connections made will enable agent forwarding.
+ # Default value: false
+ # config.ssh.forward_agent = true
+
+ # Share an additional folder to the guest VM. The first argument is
+ # the path on the host to the actual folder. The second argument is
+ # the path on the guest to mount the folder. And the optional third
+ # argument is a set of non-required options.
+ config.vm.synced_folder "..", "/home/ubuntu/monarc",
+ owner: "www-data", group: "www-data", disabled: false
+
+ # Provider-specific configuration so you can fine-tune various
+ # backing providers for Vagrant. These expose provider-specific options.
+ # Example for VirtualBox:
+ #
+ config.vm.provider "virtualbox" do |vb|
+ # # Don't boot with headless mode
+ # vb.gui = true
+ #
+ # # Use VBoxManage to customize the VM. For example to change memory:
+ vb.customize ["modifyvm", :id, "--memory", "4096"]
+ vb.customize ["modifyvm", :id, "--name", "MONARC FO - Ubuntu 17.04 - DEV"]
+ end
+ #
+ # View the documentation for the provider you're using for more
+ # information on available options.
+
+ # Enable provisioning with CFEngine. CFEngine Community packages are
+ # automatically installed. For example, configure the host as a
+ # policy server and optionally a policy file to run:
+ #
+ # config.vm.provision "cfengine" do |cf|
+ # cf.am_policy_hub = true
+ # # cf.run_file = "motd.cf"
+ # end
+ #
+ # You can also configure and bootstrap a client to an existing
+ # policy server:
+ #
+ # config.vm.provision "cfengine" do |cf|
+ # cf.policy_server_address = "10.0.2.15"
+ # end
+
+ # Enable provisioning with Puppet stand alone. Puppet manifests
+ # are contained in a directory path relative to this Vagrantfile.
+ # You will need to create the manifests directory and a manifest in
+ # the file default.pp in the manifests_path directory.
+ #
+ # config.vm.provision "puppet" do |puppet|
+ # puppet.manifests_path = "manifests"
+ # puppet.manifest_file = "site.pp"
+ # end
+
+ # Enable provisioning with chef solo, specifying a cookbooks path, roles
+ # path, and data_bags path (all relative to this Vagrantfile), and adding
+ # some recipes and/or roles.
+ #
+ # config.vm.provision "chef_solo" do |chef|
+ # chef.cookbooks_path = "../my-recipes/cookbooks"
+ # chef.roles_path = "../my-recipes/roles"
+ # chef.data_bags_path = "../my-recipes/data_bags"
+ # chef.add_recipe "mysql"
+ # chef.add_role "web"
+ #
+ # # You may also specify custom JSON attributes:
+ # chef.json = { :mysql_password => "foo" }
+ # end
+
+ # Enable provisioning with chef server, specifying the chef server URL,
+ # and the path to the validation key (relative to this Vagrantfile).
+ #
+ # The Opscode Platform uses HTTPS. Substitute your organization for
+ # ORGNAME in the URL and validation key.
+ #
+ # If you have your own Chef Server, use the appropriate URL, which may be
+ # HTTP instead of HTTPS depending on your configuration. Also change the
+ # validation key to validation.pem.
+ #
+ # config.vm.provision "chef_client" do |chef|
+ # chef.chef_server_url = "https://api.opscode.com/organizations/ORGNAME"
+ # chef.validation_key_path = "ORGNAME-validator.pem"
+ # end
+ #
+ # If you're using the Opscode platform, your validator client is
+ # ORGNAME-validator, replacing ORGNAME with your organization name.
+ #
+ # If you have your own Chef Server, the default validation client name is
+ # chef-validator, unless you changed the configuration.
+ #
+ # chef.validation_client_name = "ORGNAME-validator"
+end
diff --git a/vagrant/bootstrap.sh b/vagrant/bootstrap.sh
new file mode 100644
index 0000000..3f0cbcb
--- /dev/null
+++ b/vagrant/bootstrap.sh
@@ -0,0 +1,227 @@
+#! /usr/bin/env bash
+
+# Variables
+GITHUB_AUTH_TOKEN=$1
+
+BRANCH='master'
+#BRANCH='v0.1'
+#TAG='v0.1'
+TAG=''
+
+PATH_TO_MONARC='/home/ubuntu/monarc'
+
+APPENV='local'
+ENVIRONMENT='PRODUCTION'
+
+DBHOST='localhost'
+DBNAME_COMMON='monarc_common'
+DBNAME_CLI='monarc_cli'
+DBUSER_AMIN='root'
+DBPASSWORD_AMIN="$(openssl rand -hex 32)"
+DBUSER_MONARC='sqlmonarcuser'
+DBPASSWORD_MONARC="$(openssl rand -hex 32)"
+
+upload_max_filesize=200M
+post_max_size=50M
+max_execution_time=100
+max_input_time=223
+memory_limit=512M
+PHP_INI=/etc/php/7.0/apache2/php.ini
+
+
+echo -e "\n--- Installing MONARC FO... ---\n"
+
+echo -e "\n--- Updating packages list ---\n"
+apt-get -qq update
+
+echo -e "\n--- Install base packages ---\n"
+apt-get -y install vim zip unzip git gettext > /dev/null 2>&1
+
+echo -e "\n--- Install MariaDB (a MySQL fork/alternative) specific packages and settings ---\n"
+echo "mysql-server mysql-server/root_password password $DBPASSWORD_AMIN" | debconf-set-selections
+echo "mysql-server mysql-server/root_password_again password $DBPASSWORD_AMIN" | debconf-set-selections
+apt-get -y install mariadb-server mariadb-client > /dev/null 2>&1
+
+echo -e "\n--- Installing PHP-specific packages ---\n"
+apt-get -y install php apache2 libapache2-mod-php php-curl php-gd php-mcrypt php-mysql php-pear php-apcu php-xml php-mbstring php-intl php-imagick php-zip > /dev/null 2>&1
+
+echo -e "\n--- Configuring PHP ---\n"
+for key in upload_max_filesize post_max_size max_execution_time max_input_time memory_limit
+do
+ sed -i "s/^\($key\).*/\1 = $(eval echo \${$key})/" $PHP_INI
+done
+
+echo -e "\n--- Enabling mod-rewrite and ssl ---\n"
+a2enmod rewrite > /dev/null 2>&1
+a2enmod ssl > /dev/null 2>&1
+
+echo -e "\n--- Allowing Apache override to all ---\n"
+sudo sed -i "s/AllowOverride None/AllowOverride All/g" /etc/apache2/apache2.conf
+
+#echo -e "\n--- We want to see the PHP errors, turning them on ---\n"
+#sed -i "s/error_reporting = .*/error_reporting = E_ALL/" /etc/php/7.0/apache2/php.ini
+#sed -i "s/display_errors = .*/display_errors = On/" /etc/php/7.0/apache2/php.ini
+
+echo -e "\n--- Setting up our MySQL user for MONARC ---\n"
+mysql -u root -p$DBPASSWORD_AMIN -e "CREATE USER '$DBUSER_MONARC'@'localhost' IDENTIFIED BY '$DBPASSWORD_MONARC';"
+mysql -u root -p$DBPASSWORD_AMIN -e "GRANT ALL PRIVILEGES ON * . * TO '$DBUSER_MONARC'@'localhost';"
+mysql -u root -p$DBPASSWORD_AMIN -e "FLUSH PRIVILEGES;"
+
+echo -e "\n--- Installing composer... ---\n"
+curl -sS https://getcomposer.org/installer | sudo php -- --install-dir=/usr/local/bin --filename=composer > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "\nERROR: unable to install composer\n"
+ exit 1;
+fi
+composer self-update
+
+echo -e "\n--- Installing MONARC... ---\n"
+cd $PATH_TO_MONARC
+git config core.fileMode false
+if [ "$TAG" != '' ]; then
+ # Checkout the latest tag
+ #latestTag=$(git describe --tags `git rev-list --tags --max-count=1`)
+ git checkout $TAG
+fi
+
+echo -e "\n--- Retrieving MONARC libraries... ---\n"
+composer config -g github-oauth.github.com $GITHUB_AUTH_TOKEN
+composer install -o
+
+# Modules
+mkdir module
+cd module
+ln -s ./../vendor/monarc/core MonarcCore
+ln -s ./../vendor/monarc/frontoffice MonarcFO
+cd $PATH_TO_MONARC
+cd module/MonarcFO/
+git config core.fileMode false
+cd $PATH_TO_MONARC
+cd module/MonarcCore/
+git config core.fileMode false
+cd $PATH_TO_MONARC
+
+# Interfaces
+mkdir node_modules
+cd node_modules
+git clone --config core.filemode=false https://github.com/monarc-project/ng-client.git ng_client > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "\nERROR: unable to clone the ng-client repository\n"
+ exit 1;
+fi
+git clone --config core.filemode=false https://github.com/monarc-project/ng-anr.git ng_anr > /dev/null 2>&1
+if [ $? -ne 0 ]; then
+ echo "\nERROR: unable to clone the ng-anr repository\n"
+ exit 1;
+fi
+cd ..
+
+
+chown -R www-data $PATH_TO_MONARC
+chgrp -R www-data $PATH_TO_MONARC
+chmod -R 700 $PATH_TO_MONARC
+
+
+echo -e "\n--- Add a VirtualHost for MONARC ---\n"
+cat > /etc/apache2/sites-enabled/000-default.conf <
+ ServerName localhost
+ DocumentRoot $PATH_TO_MONARC/public
+
+
+ DirectoryIndex index.php
+ AllowOverride All
+ Require all granted
+
+
+ SetEnv APPLICATION_ENV $ENVIRONMENT
+ SetEnv APP_ENV $APPENV
+ SetEnv DB_HOST $DBHOST
+ SetEnv DB_USER $DBUSER_MONARC
+ SetEnv DB_PASS $DBPASSWORD_MONARC
+
+EOF
+echo -e "\n--- Restarting Apache ---\n"
+service apache2 restart > /dev/null 2>&1
+
+
+echo -e "\n--- Configuration of MONARC data base connection ---\n"
+cat > config/autoload/local.php < array(
+ 'connection' => array(
+ 'orm_default' => array(
+ 'params' => array(
+ 'host' => '$DBHOST',
+ 'user' => '$DBUSER_MONARC',
+ 'password' => '$DBPASSWORD_MONARC',
+ 'dbname' => '$DBNAME_COMMON',
+ ),
+ ),
+ 'orm_cli' => array(
+ 'params' => array(
+ 'host' => '$DBHOST',
+ 'user' => '$DBUSER_MONARC',
+ 'password' => '$DBPASSWORD_MONARC',
+ 'dbname' => '$DBNAME_CLI',
+ ),
+ ),
+ ),
+ ),
+
+ /* Link with (ModuleCore)
+ config['languages'] = [
+ 'fr' => array(
+ 'index' => 1,
+ 'label' => 'Français'
+ ),
+ 'en' => array(
+ 'index' => 2,
+ 'label' => 'English'
+ ),
+ 'de' => array(
+ 'index' => 3,
+ 'label' => 'Deutsch'
+ ),
+ ]
+ */
+ 'activeLanguages' => array('fr','en','de',),
+
+ 'monarc' => array(
+ 'ttl' => 20, // timeout
+ 'salt' => '', // salt privé pour chiffrement pwd
+ ),
+);
+EOF
+
+
+echo -e "\n--- Creation of the data bases---\n"
+mysql -u $DBUSER_MONARC -p$DBPASSWORD_MONARC -e "CREATE DATABASE monarc_cli DEFAULT CHARACTER SET utf8 DEFAULT COLLATE utf8_general_ci;" > /dev/null 2>&1
+mysql -u $DBUSER_MONARC -p$DBPASSWORD_MONARC -e "CREATE DATABASE monarc_common DEFAULT CHARACTER SET utf8 DEFAULT COLLATE utf8_general_ci;" > /dev/null 2>&1
+echo -e "\n--- Populating MONARC DB ---\n"
+#gunzip -k db-bootstrap/monarc-common.sql.gz
+tar -xzvf db-bootstrap/monarc-common.tar.gz -C db-bootstrap/ > /dev/null
+mysql -u $DBUSER_MONARC -p$DBPASSWORD_MONARC monarc_common < db-bootstrap/monarc-common.sql > /dev/null
+
+
+echo -e "\n--- Installation of Grunt ---\n"
+apt-get -y install nodejs > /dev/null 2>&1
+apt-get -y install npm > /dev/null 2>&1
+npm install -g grunt-cli > /dev/null 2>&1
+ln -s /usr/bin/nodejs /usr/bin/node
+
+
+echo -e "\n--- Update the project ---\n"
+/bin/bash ./scripts/update-all.sh
+
+
+echo -e "\n--- Create initial user and client ---\n"
+php ./vendor/robmorgan/phinx/bin/phinx seed:run -c ./module/MonarcFO/migrations/phinx.php
+
+
+echo -e "\n--- Restarting Apache ---\n"
+service apache2 restart > /dev/null 2>&1
+
+
+echo -e "\n--- MONARC is ready! Point your Web browser to http://127.0.0.1:5001 ---\n"